package com.liquidnet.service.sweet.handler;

import com.liquidnet.service.sweet.config.WechatMaConfigure;
import com.liquidnet.service.sweet.utils.WechatUsersRedisUtils;
import lombok.extern.slf4j.Slf4j;
import me.chanjar.weixin.common.error.WxErrorException;
import me.chanjar.weixin.common.session.WxSessionManager;
import me.chanjar.weixin.mp.api.WxMpMessageHandler;
import me.chanjar.weixin.mp.api.WxMpService;
import me.chanjar.weixin.mp.bean.kefu.WxMpKefuMessage;
import me.chanjar.weixin.mp.bean.message.WxMpXmlMessage;
import me.chanjar.weixin.mp.bean.message.WxMpXmlOutMessage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Map;

/**
 * <p>
 * 2021草莓音乐节海报活动菜单点击
 * </p>
 *
 * @author jiangxiulong
 * @since 2021-11-25
 */
@Component
@Slf4j
public class StrawberryPosterHandler implements WxMpMessageHandler {

    @Autowired
    private WechatUsersRedisUtils redisUtils;

    @Autowired
    WechatMaConfigure maConfigure;

    @Override
    public WxMpXmlOutMessage handle(WxMpXmlMessage wxMessage, Map<String, Object> context, WxMpService wxMpService,
                                    WxSessionManager sessionManager) throws WxErrorException {
        redisUtils.setStrawberryPosterClick(wxMessage.getFromUser(), 10 * 60);

        // test 小程序卡片
        WxMpKefuMessage message = WxMpKefuMessage.MINIPROGRAMPAGE()
                .appId(maConfigure.getWxMaAppid(4))
                .pagePath("/pages/index")
                .thumbMediaId("ov08q51In7bXX6tXv7FewxFNN0G78n-pPRsbi3LZbPE")
                .title("正在摩登")
                .toUser(wxMessage.getFromUser())
                .build();
        // 设置消息的内容等信息
        wxMpService.getKefuService().sendKefuMessage(message);


        // TODO: 2021/11/25 线上改成正规文案
        return WxMpXmlOutMessage.TEXT().content("您已进入活动，请回复姓名，zhengzai.tv, 10分钟内回复有效")
                .fromUser(wxMessage.getToUser()).toUser(wxMessage.getFromUser())
                .build();
    }
}
